/*
 * @(#)ea_funcs.h	1.2
 * Special functions for 83C196EA and compatible processors.
 */

#ifndef _ea_funcs_h
#define _ea_funcs_h

void            enable(void);
void            disable(void);

void            enable_pts(void);
void            disable_pts(void);

void            power_down(void);
void            idle(void);

/****************************************************************************/
/* Define typedefs for PTS Control Blocks of 83C196EA.                      */
/****************************************************************************/

/*
 * Single Transfer PTS Control Block
 */
typedef struct STran_ptscb_t
{
    unsigned char       ptscount;
    struct
    {
        unsigned int        di   : 1;
        unsigned int        si   : 1;
        unsigned int        du   : 1;
        unsigned int        su   : 1;
        unsigned int        b_w  : 1;
        unsigned int        mode : 3;
    } ptscon;
    near void          *ptssrc;
    near void          *ptsdst;
    int                 :16;                                /* unused */
} STran_ptscb;


/*
 * Block Transfer PTS Control Block
 */
typedef struct BTran_ptscb_t
{
    unsigned char       ptscount;
    struct
    {
        unsigned int        di   : 1;
        unsigned int        si   : 1;
        unsigned int        du   : 1;
        unsigned int        su   : 1;
        unsigned int        b_w  : 1;
        unsigned int        mode : 3;
    } ptscon;
    near void          *ptssrc;
    near void          *ptsdst;
    unsigned char       ptsburst;
    int                 :8;                                 /* unused */
} BTran_ptscb;


/*
 * Dummy Mode PTS Control Block
 */
typedef struct Dummy_ptscb_t
{
    int                 :8;                                 /* unused */
    struct
    {
        unsigned int        unused : 5;
        unsigned int        mode   : 3;
    } ptscon;
    int                 :16;                                /* unused */
    int                 :16;                                /* unused */
    int                 :16;                                /* unused */
} Dummy_ptscb;

#endif  /* _nt_funcs_h */
