/*
 * @(#)nu_funcs.h	1.2
 * Special functions for 80C196NU and compatible processors.
 */
#ifndef _nu_funcs_h
#define _nu_funcs_h

void            enable(void);
void            disable(void);

void            enable_pts(void);
void            disable_pts(void);

void            power_down(void);
void            idle(void);

/****************************************************************************/
/* Define typedefs for PTS Control Blocks of 80C196NU.                      */
/****************************************************************************/

/*
 * Single Transfer PTS Control Block
 */
typedef struct STran_ptscb_t
{
    unsigned char       ptscount;
    struct
    {
        unsigned int        di   : 1;
        unsigned int        si   : 1;
        unsigned int        du   : 1;
        unsigned int        su   : 1;
        unsigned int        b_w  : 1;
        unsigned int        mode : 3;
    } ptscon;
    near void          *ptssrc;
    near void          *ptsdst;
    int                 :16;                                /* unused */
} STran_ptscb;


/*
 * Burst Transfer PTS Control Block
 */
typedef struct BTran_ptscb_t
{
    unsigned char       ptscount;
    struct
    {
        unsigned int        di   : 1;
        unsigned int        si   : 1;
        unsigned int        du   : 1;
        unsigned int        su   : 1;
        unsigned int        b_w  : 1;
        unsigned int        mode : 3;
    } ptscon;
    near void          *ptssrc;
    near void          *ptsdst;
    unsigned char       ptsburst;
    int                 :8;                                 /* unused */
} BTran_ptscb;


/*
 *  PTS PWM
 */
typedef struct PWM_ptscb_t
{
    int                 :8;                                 /* unused */
    struct
    {
        unsigned int        tbit   : 1;
        unsigned int        tmod   : 1;
        unsigned int        const1 : 3;
        unsigned int        mode   : 3;
    } ptscon;
    near void           *ptsptr1;
    unsigned int        ptsconst1;
    int                 :16;
} PWM_ptscb;


/*
 *  PTS PWM Toggle
 */
typedef struct PWMtoggle_ptscb_t
{
    int                 :8;                                 /* unused */
    struct
    {
        unsigned int        tbit   : 1;
        unsigned int        tmod   : 1;
        unsigned int        const1 : 3;
        unsigned int        mode   : 3;
    } ptscon;
    near void           *ptsptr1;
    unsigned int        ptsconst1;
    unsigned int        ptsconst2;
} PWMtoggle_ptscb;

#endif  /* _nu_funcs_h */
